



#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/types.h>
#include <linux/watchdog.h>



int main(int argc, const char *argv[]) 
{
	struct watchdog_info ident;
	int timeout = 50;
	int i;

        int fd=open("/dev/watchdog",O_WRONLY);
        if (fd==-1) {
                perror("watchdog");
                exit(1);
        }

        for (i=0;i<3;i++) {
                write(fd, "\0", 1);
                sleep(10);
        }
	
	ioctl(fd, WDIOC_SETTIMEOUT, &timeout);
	printf("The timeout was set to %d seconds\n", timeout);

	ioctl(fd, WDIOC_GETTIMEOUT, &timeout);
	printf("The timeout was is %d seconds\n", timeout);
	
	printf("Ping via ioctl...\n");
	ioctl(fd, WDIOC_KEEPALIVE, 0);

	ioctl(fd, WDIOC_GETSUPPORT, &ident);
	printf("WDIOC_GETSUPPORT: ident.identity = %s\n",ident.identity);
	printf("WDIOC_GETSUPPORT: ident.firmware_version = %d\n",
	       ident.firmware_version);
	printf("WDIOC_GETSUPPORT: ident.options = 0x%x\n",ident.options);
	
	if ( ident.options & WDIOF_KEEPALIVEPING )
		printf("\tKeep alive ping reply.\n");

	if ( ident.options & WDIOF_SETTIMEOUT )
		printf("\tCan set/get the timeout.\n");

	printf("Turn off the watchdog timer\n");
	ioctl(fd, WDIOC_SETOPTIONS,WDIOS_DISABLECARD );

	printf("sleeping (10s)...\n");
	sleep(10);

	printf("Turn on the watchdog timer\n");
	ioctl(fd, WDIOC_SETOPTIONS, WDIOS_ENABLECARD );

	
	for (i=0;i<3;i++) {
                write(fd, "\0", 1);
                sleep(10);
        }
	
	printf("Send magic character: V\n");
	write(fd, "V", 1);
	printf("Close for stopping..\n");
	close(fd);

	return 0;
}
